<template>
  <div v-if="show_render">
    <q-card class="q-ma-md" flat bordered>
    <div v-if="table_divs" class="rendered_table q-pa-sm"  :key="language_switch" role="grid" aria-label="Rendered dimensions">
      <q-expansion-item label="Dimensional table" header-class="heading_expansion__table" default-opened
                              expand-icon-class="text-orange-10" switch-toggle-side role="heading">
        <div class="q-mt-sm">
        <span v-html="table_css"></span>
        <TableNode :node="table_divs" v-on:nodeClicked="nodeClicked" v-on:conceptClicked="nodeClicked"></TableNode>
        </div>
      </q-expansion-item>
    </div>
    <div v-else class="q-pa-sm">
      Ophalen gegevens..
      <q-linear-progress indeterminate rounded color="accent" class="q-mt-sm"/>
    </div>
    </q-card>
  </div>

</template>

<script>
import SharedMethods from "components/SharedMethods";
import {api} from "boot/axios";
import _ from "lodash";
import TableNode from "components/TableNode";

export default {
  name: "Hypercube",
  components: {TableNode},
  emits: ["nodeClicked", "concept_clicked"],
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
  },
  props: {
    linkrole_rowid: undefined,
    dts_name: String,
    nt_version: String,
  },
  data() {
    return {
      table_divs: undefined,
      table_css: undefined,
      concept_detail_id: undefined,
      style: "style",
      language_switch: 0,
    }
  },
  watch: {
    linkrole_rowid: function () {
      this.fetchData()
    },
  },
  methods: {
    fetchData: function () {
      if (!_.isUndefined(this.linkrole_rowid)) {
        api
          .get("/dts/" + this.dts_name + "/render_hypercube/" + this.linkrole_rowid,
            {params: {nt_version: this.nt_version, full: 1}})
          .then(response => {
            this.table_css = response.data.css
            this.table_divs = response.data.divs
          })
      }
    },
    nodeClicked: function (node) {
      this.$emit('concept_clicked', node)
    }
  },
  computed: {
    show_render: function () {
      if (this.$route.path.includes("/definition")) {
        return true
      }
      return false
    }
  }

}
</script>

<style scoped>

</style>
